<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class MapaFaturamentoFactory
{
    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    // select principal
    public function getMapaFaturamento($page, $limit, $conditions, $order)
    {   
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT MES1.CDSERVORCA, MES1.NMSERVORCA,
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
               FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                       ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO1, ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA1,
                       ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO1
                 FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
               JOIN FCT_CONTRATO CONT 
               ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                   ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                 AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
                   GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES1
               LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                       ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO2, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA2,
                       ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO2
                 FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
               JOIN FCT_CONTRATO CONT 
               ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                   ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
                   GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES2
                 ON MES2.CDSERVORCA = MES1.CDSERVORCA
               LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                       ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO3, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA3,
                       ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO3
                 FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
               JOIN FCT_CONTRATO CONT 
               ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                   ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
                   GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES3
                 ON MES3.CDSERVORCA = MES1.CDSERVORCA) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }

    // Trás parceiros de negócio
    public function getMapaFaturamentoParc($parametros, $page, $limit, $conditions, $order)
    {
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT  DECODE(MES1.CDSERVORCA, NULL, DECODE(MES2.CDSERVORCA, NULL, MES3.CDSERVORCA, MES2.CDSERVORCA), MES1.CDSERVORCA) AS CDSERVORCA,  
                       DECODE(MES1.NRPARCFATURA, NULL, DECODE(MES2.NRPARCFATURA, NULL, MES3.NRPARCFATURA, MES2.NRPARCFATURA), MES1.NRPARCFATURA) AS NRPARCNEGOCIO, 
                       DECODE(MES1.NMPARCEIRO, NULL, DECODE(MES2.NMPARCEIRO, NULL, MES3.NMPARCEIRO, MES2.NMPARCEIRO), MES1.NMPARCEIRO) AS NMPARCEIRO,
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
                 FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                       ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO1, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA1,
                       ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100, 2) AS DESVIO1
                       FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                 JOIN PARCNEGOCIO PARC 
                   ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
               JOIN FCT_CONTRATO CONT 
               ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
               ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
               WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
               AND SERV.CDSERVORCA = :CDSERVORCA
                 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES1
               FULL JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                     ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO2, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA2,
                     ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO2
                 FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                 JOIN PARCNEGOCIO PARC 
                   ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
               JOIN FCT_CONTRATO CONT 
               ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
               ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO  
               WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
               AND SERV.CDSERVORCA = :CDSERVORCA
                 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )',  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES2
               ON MES2.CDSERVORCA = MES1.CDSERVORCA
               AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
               FULL JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                     ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO3, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA3,
                     ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO3
                 FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                 JOIN PARCNEGOCIO PARC 
                   ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
               JOIN FCT_CONTRATO CONT 
               ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
               ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
               WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
                 AND SERV.CDSERVORCA = :CDSERVORCA
               GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES3
               ON MES3.CDSERVORCA = MES2.CDSERVORCA
               AND((MES3.NRPARCFATURA = MES2.NRPARCFATURA) OR (MES3.NRPARCFATURA = MES1.NRPARCFATURA))
               ORDER BY DESVIO1 ASC, DESVIO2 ASC, DESVIO3 ASC) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql, $parametros);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }

    // trás os contratos
    public function getMapaFaturamentoCli($parametros, $page, $limit, $conditions, $order)
    {
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT DECODE(MES1.CDSERVORCA, NULL, DECODE(MES2.CDSERVORCA, NULL, MES3.CDSERVORCA, MES2.CDSERVORCA), MES1.CDSERVORCA) AS CDSERVORCA,  
                       DECODE(MES1.NRSEQCONTRATO, NULL, DECODE(MES2.NRSEQCONTRATO, NULL, MES3.NRSEQCONTRATO, MES2.NRSEQCONTRATO), MES1.NRSEQCONTRATO) AS NRSEQCONTRATO,
                       DECODE(MES1.CONTRATO, NULL, DECODE(MES2.CONTRATO, NULL, MES3.CONTRATO, MES2.CONTRATO), MES1.CONTRATO) AS CONTRATO,
                       DECODE(MES1.NRPARCFATURA, NULL, DECODE(MES2.NRPARCFATURA, NULL, MES3.NRPARCFATURA, MES2.NRPARCFATURA), MES1.NRPARCFATURA) AS NRPARCNEGOCIO, 
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
                 FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                       ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO1, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA1,
                       ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO1
                     FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                 JOIN PARCNEGOCIO PARC 
                   ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                 JOIN FCT_CONTRATO CONT
                   ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
               ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
                 AND SERV.CDSERVORCA = :CDSERVORCA
                 AND PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                   GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES1
               FULL JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                       ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO2, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA2,
                       ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO2 
                 FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                 JOIN PARCNEGOCIO PARC 
                   ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                 JOIN FCT_CONTRATO CONT
                   ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
               ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
                 AND SERV.CDSERVORCA = :CDSERVORCA
                 AND PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                   GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
                   ORDER BY  SERV.NMSERVORCA) MES2
                 ON MES2.CDSERVORCA = MES1.CDSERVORCA
                 AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
                 AND MES2.NRSEQCONTRATO = MES1.NRSEQCONTRATO
                 FULL JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                       ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO3, 
               ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
               ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA3,
                       ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO3
                 FROM FCT_FATURACONT FAT
                 JOIN FCT_ITFATURACONT ITEM
                   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                 JOIN FCT_ITEMCONTRATO ITCONT
                   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                 JOIN FCT_SERVICOORCA SERV
                   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                 JOIN PARCNEGOCIO PARC 
                   ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                 JOIN FCT_CONTRATO CONT
                   ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
               ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
               ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
               AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
               WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
                 AND SERV.CDSERVORCA = :CDSERVORCA
                 AND PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO
               GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
               ORDER BY  SERV.NMSERVORCA) MES3
                 ON MES3.CDSERVORCA = MES2.CDSERVORCA
                 AND((MES3.NRPARCFATURA = MES2.NRPARCFATURA) OR (MES3.NRPARCFATURA = MES1.NRPARCFATURA))
                 AND((MES3.NRSEQCONTRATO = MES2.NRSEQCONTRATO) OR (MES3.NRSEQCONTRATO = MES1.NRSEQCONTRATO))) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql, $parametros);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }

    // select do xml - todos os dados reunidos
    public function getDadosFaturamentoCompleto($page, $limit, $conditions, $order)
    {
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT * 
        FROM (SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, NULL AS NRSEQCONTRATO, NULL AS CONTRATO, NULL AS NRPARCNEGOCIO, NULL AS NMPARCEIRO, 'S_'||MES1.CDSERVORCA AS DSARVORE, NULL AS DSARVORESUP,
                NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS NAO_DIFERENCA,
                CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_POSITIVO,
                CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_NEGATIVO,
                CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_ZERADO,
                '' AS DESVIO_SINAL
         FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO1, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA1,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO1
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
		   JOIN FCT_CONTRATO CONT 
		     ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO2, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA2,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO2
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
		   JOIN FCT_CONTRATO CONT 
		     ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO3, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA3,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
		   JOIN FCT_CONTRATO CONT 
		     ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          
          UNION ALL
          
          SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, NULL AS NRSEQCONTRATO, NULL AS CONTRATO, MES1.NRPARCFATURA AS NRPARCNEGOCIO, MES1.NMPARCEIRO, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA AS DSARVORE, 'S_'||MES1.CDSERVORCA AS DSARVORESUP,
                 NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS NAO_DIFERENCA,
                CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_POSITIVO,
                CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_NEGATIVO,
                CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_ZERADO,
                '' AS DESVIO_SINAL
           FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO1, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA1,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO1 
               FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
		   JOIN FCT_CONTRATO CONT 
		     ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO2, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA2,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
		   JOIN FCT_CONTRATO CONT 
		     ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )',  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
          AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
          LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO3, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA3,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
		   JOIN FCT_CONTRATO CONT 
		     ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          AND MES3.NRPARCFATURA = MES1.NRPARCFATURA
          
          UNION ALL
          
          SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, MES1.NRSEQCONTRATO, MES1.CONTRATO, MES1.NRPARCFATURA AS NRPARCNEGOCIO, MES1.NMPARCEIRO, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA||'_C_'||MES1.NRSEQCONTRATO AS DSARVORE, 'S_'||MES1.CDSERVORCA||'_P_'||MES1.NRPARCFATURA AS DSARVORESUP,
                NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS NAO_DIFERENCA,
                CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_POSITIVO,
                CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_NEGATIVO,
                CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                  THEN 'S'
                  ELSE 'N'
                END AS DESVIO_ZERADO,
                '' AS DESVIO_SINAL
           FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO1, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA1,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO1 
               FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
           JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES1
         LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO2, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA2,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO2 
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
           JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES2
          ON MES2.CDSERVORCA = MES1.CDSERVORCA
          AND MES2.NRPARCFATURA = MES1.NRPARCFATURA
          AND MES2.NRSEQCONTRATO = MES1.NRSEQCONTRATO
          LEFT JOIN (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2) AS ESTIMADO3, 
				ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
				ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) AS DIFERENCA3,
                ROUND((ROUND((SUM(ITEM.VRFATURADO) - SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)))),2) / DECODE(ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2),0,1, ROUND(SUM(DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))),2)))*100,2) AS DESVIO3
           FROM FCT_FATURACONT FAT
           JOIN FCT_ITFATURACONT ITEM
             ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
           JOIN FCT_ITEMCONTRATO ITCONT
             ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
           JOIN FCT_SERVICOORCA SERV
             ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
           JOIN PARCNEGOCIO PARC 
             ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
           JOIN FCT_CONTRATO CONT
             ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
		   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
			 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
		   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
			 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
		    AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
          WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
            GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY')
             ORDER BY  SERV.NMSERVORCA) MES3
          ON MES3.CDSERVORCA = MES1.CDSERVORCA
          AND MES3.NRPARCFATURA = MES1.NRPARCFATURA
          AND MES3.NRSEQCONTRATO = MES1.NRSEQCONTRATO)
          ORDER BY CDSERVORCA, NRPARCNEGOCIO DESC, NRSEQCONTRATO DESC) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }
}
