<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00016000TipoAnexoFactory
{

    use TQuery;

    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }

    public function getTipoAnexo()
    {
        $sql = "SELECT NRTIPOANEXO,
                       NMTIPOANEXO,
                       IDATIVO
                  FROM FCT_TIPOANEXO";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirAnexos($params)
    {
        $sql = "INSERT INTO FCT_TIPOANEXO (
                    NRTIPOANEXO,    NMTIPOANEXO,   NRORG,
                    IDATIVO,        NRORGINCLUSAO, DTINCLUSAO,
                    CDOPERINCLUSAO
                )
                VALUES (
                    :NRTIPOANEXO,    :NMTIPOANEXO,   :NRORG,
                    :IDATIVO,        :NRORGINCLUSAO, SYSDATE,
                    :CDOPERINCLUSAO
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function editarAnexos($params)
    {
        $sql = "UPDATE FCT_TIPOANEXO
                   SET IDATIVO      = :IDATIVO, 
                       NMTIPOANEXO  = :NMTIPOANEXO, 
                       NRORGULTATU  = :NRORGULTATU, 
                       CDOPERULTATU = :CDOPERULTATU,
                       DTULTATU     = SYSDATE
                 WHERE NRTIPOANEXO = :NRTIPOANEXO";

        $this->connection->executeStatement($sql, $params);
    }
    
    public function excluirTipoAnexo($parametro)
    {
        $sql = "DELETE FROM FCT_TIPOANEXO
                 WHERE NRTIPOANEXO IN (".$parametro.")";
        
        $this->connection->executeStatement($sql);
    }
}
