import { AppController } from './AppController';
import { LoginController } from './LoginController';
import { DashboardController } from './Dashboard/DashboardController';
import { FrameBillingController } from './Dashboard/FrameBillingController';
import { FrameContractsController } from './Dashboard/FrameContractsController';
import { FrameProposalController } from './Dashboard/FrameProposalController';
import { ComparativoFaturamentoController } from './Billing/ComparativoFaturamentoController';
import { LogCallbackCertisignController } from './CallbackCertisign/LogCallbackCertisignController';
import { CentroCustoRelatorioController } from './CentroCustoRelatorioController';
import { AgrupamentoContratoController } from './Faturamento/AgrupamentoContratoController';
import { SmNext00006000servicosController } from './SmNext00006000servicosController';
import { ClientesNaoFaturadosRelatorioController } from './ClientesNaoFaturadosRelatorioController';
import { MapaFaturamentoController } from './MapaFaturamentoController';
import { Sm00057001ConfiguracaoRegionalIdiomaController } from './Sm00057000ConfiguracaoRegional/Sm00057001ConfiguracaoRegionalIdiomaController';
import { Sm00057002ConfiguracaoRegionalMoedaController } from './Sm00057000ConfiguracaoRegional/Sm00057002ConfiguracaoRegionalMoedaController';
import { Sm00037000MotivoNegociacaoController } from './Sm00037000MotivoNegociacaoController';
import { Sm00016000TipoAnexoController } from './Sm00016000TipoAnexoController';
import { Sm00004110TipoRescisaoController } from './Sm00004110TipoRescisaoController';
import { Sm00036000MotivoRescisaoController } from './Sm00036000MotivoRescisaoController';
import { Sm00024000ModeloDocumentosController } from './Sm00024000ModeloDocumentosController';
import { Sm00006000TipoDeMedidaController } from './Sm00006000TipoDeMedidaController/Sm00006000TipoDeMedidaController';
import { Sm00029001TipoLocalAtendimentoController } from './Sm00029001TipoLocalAtendimentoController';
import { Sm00052001DescontoMaximoServicoOperadorController } from './Sm00052000DescontoMaximoServico/Sm00052001DescontoMaximoServicoOperadorController';
import { FilterCdaController } from './CdaController/FilterCdaController';
import { AtividadeCdaController } from './CdaController/AtividadeCdaController';
import { ModeloDocumentosCdaController } from './CdaController/ModeloDocumentosCdaController';
import { Sm00052002DescontoMaximoServicoPerfilAcessoController } from './Sm00052000DescontoMaximoServico/Sm00052002DescontoMaximoServicoPerfilAcessoController';
import { Sm00001002PropostaHistoricoController } from './Sm00001002PropostaHistoricoController';
import { Sm00050001QuantidadeMaximaParcelasOperadorController } from './Sm00050000QuantidadeMaximaParcelas/Sm00050001QuantidadeMaximaParcelasOperadorController';
import { Sm00050002QuantidadeMaximaParcelasPerfilAcessoController } from './Sm00050000QuantidadeMaximaParcelas/Sm00050002QuantidadeMaximaParcelasPerfilAcessoController';
import { Sm00034001DescontoPeriodoCarenciaOperadorController } from './Sm00034000DescontoPeriodoCarencia/Sm00034001DescontoPeriodoCarenciaOperadorController';
import { Sm00034002DescontoPeriodoCarenciaPerfilAcessoController } from './Sm00034000DescontoPeriodoCarencia/Sm00034002DescontoPeriodoCarenciaPerfilAcessoController';
import { Sm00054001ReducaoQuantidadeMedidaController } from './Sm00054000ReducaoQuantidadeMedida/Sm00054001ReducaoQuantidadeMedidaController';
import { Sm00054002ReducaoQuantidadeMedidaController } from './Sm00054000ReducaoQuantidadeMedida/Sm00054002ReducaoQuantidadeMedidaController';
import { Sm00011000TabApuracaoFaturamentoController } from './Sm00011000ApuracaoFaturamentoController/Sm00011000TabApuracaoFaturamentoController';
import { Sm00011000TabItensApuracaoFaturamentoController } from './Sm00011000ApuracaoFaturamentoController/Sm00011000TabItensApuracaoFaturamentoController';
import { Sm00011000TabDadosAgrupamentoController } from './Sm00011000ApuracaoFaturamentoController/Sm00011000TabDadosAgrupamentoController';
import { Sm00005000TabParametrizacoesServicesController } from './Sm00005000ParametrizacoesServicesController/Sm00005000TabParametrizacoesServicesController';
import { Sm00005000TabParametrizacoesServicesEmailController } from './Sm00005000ParametrizacoesServicesController/Sm00005000TabParametrizacoesServicesEmailController';
import { Sm00005000TabParametrizacoesIndicesPadroesController } from './Sm00005000ParametrizacoesServicesController/Sm00005000TabParametrizacoesIndicesPadroesController';
import { Sm00005000TabParametrizacoesSignatariosPadroesController } from './Sm00005000ParametrizacoesServicesController/Sm00005000TabParametrizacoesSignatariosPadroesController';
import { Sm00001001DocumentoPropostaController } from './Sm00001001DocumentoProposta/Sm00001001DocumentoPropostaController';
import { Sm00001001TabDocumentoPropostaController } from './Sm00001001DocumentoProposta/Sm00001001TabDocumentoPropostaController';
import { Sm00001001TabAnexosDocumentoPropostaController } from './Sm00001001DocumentoProposta/Sm00001001TabAnexosDocumentoPropostaController';
import { Sm00004006DocumentoContratoController } from './Sm00004006DocumentoContratoController/Sm00004006DocumentoContratoController';
import { Sm00004006TabDocumentoContratoController } from './Sm00004006DocumentoContratoController/Sm00004006TabDocumentoContratoController';
import { Sm00004006TabAnexosDocumentoContratoController } from './Sm00004006DocumentoContratoController/Sm00004006TabAnexosDocumentoContratoController';
import { Sm00006000ElementoController } from './Sm00006000ElementoController';
import { Sm00070000HierarquiaOperadoresController } from './Sm00070000HierarquiaOperadoresController';
import { ComposicaoServicosController } from './ComposicaoServicosController';
import { AgendaServicosController } from './AgendaServicosController';
import { Sm00001101RelatorioCustomizavelPropostaController } from './Sm00001101RelatorioCustomizavelPropostaController';
import { ContractModelController } from './ContractModelController';
import { EscopoFaturamentoController } from './EscopoFaturamento/EscopoFaturamentoController';
import { EscopoFaturamentoTabTabelaPrecoController } from './EscopoFaturamento/EscopoFaturamentoTabTabelaPrecoController';
import { EscopoFaturamentoTabServicoEscopo } from './EscopoFaturamento/EscopoFaturamentoTabServicoEscopo';
import { EscopoFaturamentoTabParametrizacoesIndicesPadroesController } from './EscopoFaturamento/EscopoFaturamentoTabParametrizacoesIndicesPadroesController';
import { ServicoEscopoTabParametrosFaturamentoController } from './EscopoFaturamento/ServicoEscopoTabParametrosFaturamentoController';
import { ServicoEscopoTabCompetenciaController } from './EscopoFaturamento/ServicoEscopoTabCompetenciaController';
import { DescricaoEscopoTabDescricaoEscopoController } from './EscopoFaturamento/DescricaoEscopoTabDescricaoEscopoController';
import { ProposalModelController } from './ProposalModelController';
import { Sm00004101RelatorioCustomizavelContratoController } from './Sm00004101RelatorioCustomizavelContratoController';
import { JustifCancelaApurController } from './JustifCancelaApurController/JustifCancelaApurController';
import { SmAgrupamentoEscopoController } from './SmAgrupamentoEscopoController/SmAgrupamentoEscopoController';

export default {
    AppController,
    LoginController,
    DashboardController,
    FrameBillingController,
    FrameContractsController,
    FrameProposalController,
    ComparativoFaturamentoController,
    LogCallbackCertisignController,
    CentroCustoRelatorioController,
    AgrupamentoContratoController,
    SmNext00006000servicosController,
    ClientesNaoFaturadosRelatorioController,
    MapaFaturamentoController,
    Sm00057001ConfiguracaoRegionalIdiomaController,
    Sm00057002ConfiguracaoRegionalMoedaController,
    Sm00037000MotivoNegociacaoController,
    Sm00016000TipoAnexoController,
    Sm00004110TipoRescisaoController,
    Sm00036000MotivoRescisaoController,
    Sm00024000ModeloDocumentosController,
    Sm00006000TipoDeMedidaController,
    Sm00029001TipoLocalAtendimentoController,
    Sm00052001DescontoMaximoServicoOperadorController,
    FilterCdaController,
    AtividadeCdaController,
    ModeloDocumentosCdaController,
    Sm00052002DescontoMaximoServicoPerfilAcessoController,
    Sm00001002PropostaHistoricoController,
    Sm00050001QuantidadeMaximaParcelasOperadorController,
    Sm00050002QuantidadeMaximaParcelasPerfilAcessoController,
    Sm00034001DescontoPeriodoCarenciaOperadorController,
    Sm00034002DescontoPeriodoCarenciaPerfilAcessoController,
    Sm00054001ReducaoQuantidadeMedidaController,
    Sm00054002ReducaoQuantidadeMedidaController,
    Sm00011000TabApuracaoFaturamentoController,
    Sm00011000TabItensApuracaoFaturamentoController,
    Sm00011000TabDadosAgrupamentoController,
    Sm00005000TabParametrizacoesServicesController,
    Sm00005000TabParametrizacoesServicesEmailController,
    Sm00001001DocumentoPropostaController,
    Sm00001001TabDocumentoPropostaController,
    Sm00001001TabAnexosDocumentoPropostaController,
    Sm00004006DocumentoContratoController,
    Sm00004006TabDocumentoContratoController,
    Sm00004006TabAnexosDocumentoContratoController,
    Sm00005000TabParametrizacoesIndicesPadroesController,
    Sm00005000TabParametrizacoesSignatariosPadroesController,
    Sm00006000ElementoController,
    Sm00070000HierarquiaOperadoresController,
    ComposicaoServicosController,
    AgendaServicosController,
    Sm00001101RelatorioCustomizavelPropostaController,
    ContractModelController,
    EscopoFaturamentoController,
    EscopoFaturamentoTabTabelaPrecoController,
    EscopoFaturamentoTabServicoEscopo,
    EscopoFaturamentoTabParametrizacoesIndicesPadroesController,
    ServicoEscopoTabParametrosFaturamentoController,
    ServicoEscopoTabCompetenciaController,
    DescricaoEscopoTabDescricaoEscopoController,
    ProposalModelController,
    Sm00004101RelatorioCustomizavelContratoController,
    JustifCancelaApurController,
    SmAgrupamentoEscopoController,
};
